
dnl Adapted from lib-prefix.m4 serial 5 (gettext-0.15)
dnl
dnl ARC_PREPARE_PREFIX creates variables arc_final_prefix,
dnl arc_final_exec_prefix, containing the values to which $prefix and
dnl $exec_prefix will expand at the end of the configure script.
AC_DEFUN([ARC_PREPARE_PREFIX],
[
  dnl Unfortunately, prefix and exec_prefix get only finally determined
  dnl at the end of configure.
  if test "X$prefix" = "XNONE"; then
    arc_final_prefix="$ac_default_prefix"
  else
    arc_final_prefix="$prefix"
  fi
  if test "X$exec_prefix" = "XNONE"; then
    arc_final_exec_prefix='${prefix}'
  else
    arc_final_exec_prefix="$exec_prefix"
  fi
  arc_save_prefix="$prefix"
  prefix="$arc_final_prefix"
  eval arc_final_exec_prefix=\"$arc_final_exec_prefix\"
  prefix="$arc_save_prefix"
])

dnl Adapted from lib-prefix.m4 serial 5 (gettext-0.15)
dnl
dnl ARC_WITH_FINAL_PREFIX([statement]) evaluates statement, with the
dnl variables prefix and exec_prefix bound to the values they will have
dnl at the end of the configure script.
AC_DEFUN([ARC_WITH_FINAL_PREFIX],
[
  arc_save_prefix="$prefix"
  prefix="$arc_final_prefix"
  arc_save_exec_prefix="$exec_prefix"
  exec_prefix="$arc_final_exec_prefix"
  $1
  exec_prefix="$arc_save_exec_prefix"
  prefix="$arc_save_prefix"
])
