dnl
dnl Substitite some relative paths
dnl

AC_DEFUN([ARC_RELATIVE_PATHS],
[
  AC_REQUIRE([ARC_RELATIVE_PATHS_INIT])
  AC_REQUIRE([ARC_PREPARE_PREFIX])

  ARC_WITH_FINAL_PREFIX([
      eval final_prefix="\"${prefix}\""
      eval final_eprefix="\"${exec_prefix}\""
      eval final_bindir="\"${bindir}\""
      eval final_libdir="\"${libdir}\""
      eval final_libexecdir="\"${libexecdir}\""
      eval final_pkglibdir="\"${pkglibdir}\""
      eval final_pkglibexecdir="\"${pkglibexecdir}\""
      eval final_pkgdatadir="\"${pkgdatadir}\""
      eval final_pkgdatadir="\"${final_pkgdatadir}\""
  ])

  libsubdir=`get_relative_path "$final_eprefix" "$final_libdir"`
  libexecsubdir=`get_relative_path "$final_eprefix" "$final_libexecdir"`
  pkglibsubdir=`get_relative_path "$final_eprefix" "$final_pkglibdir"`
  pkglibexecsubdir=`get_relative_path "$final_eprefix" "$final_pkglibexecdir"`
  pkgdatasubdir=`get_relative_path "$final_prefix" "$final_pkgdatadir"`
  pkglibdir_rel_to_pkglibexecdir=`get_relative_path "$final_pkglibexecdir" "$final_pkglibdir"`

  AC_MSG_NOTICE([pkglib subdirectory is: $pkglibsubdir])
  AC_MSG_NOTICE([pkglibexec subdirectory is: $pkglibexecsubdir])
  AC_MSG_NOTICE([pkgdata subdirectory is: $pkgdatasubdir])
  AC_MSG_NOTICE([relative path of pkglib to pkglibexec is: $pkglibdir_rel_to_pkglibexecdir])

  AC_SUBST([libsubdir])
  AC_SUBST([pkglibsubdir])
  AC_SUBST([libexecsubdir])
  AC_SUBST([pkglibexecsubdir])
  AC_SUBST([pkgdatasubdir])
  AC_SUBST([pkglibdir_rel_to_pkglibexecdir])

  AC_DEFINE_UNQUOTED([LIBSUBDIR], ["${libsubdir}"], [library installation subdirectory])
  AC_DEFINE_UNQUOTED([LIBEXECSUBDIR], ["${libexecsubdir}"], [libexec subdirectory, deprecated])
  AC_DEFINE_UNQUOTED([PKGLIBSUBDIR], ["${pkglibsubdir}"], [plugin installation subdirectory])
  AC_DEFINE_UNQUOTED([PKGLIBEXECSUBDIR], ["${pkglibexecsubdir}"], [helper programs installation subdirectory])

])

AC_DEFUN([ARC_RELATIVE_PATHS_INIT],
[
  get_relative_path() {
    olddir=`echo $[]1 | sed -e 's|/+|/|g' -e 's|^/||' -e 's|/*$|/|'`
    newdir=`echo $[]2 | sed -e 's|/+|/|g' -e 's|^/||' -e 's|/*$|/|'`
    
    O_IFS=$IFS
    IFS=/
    relative=""
    common=""
    for i in $olddir; do
      if echo "$newdir" | grep -q "^$common$i/"; then
        common="$common$i/"
      else
        relative="../$relative"
      fi
    done
    IFS=$O_IFS
    echo $newdir | sed "s|^$common|$relative|" | sed 's|/*$||'
  }
])

