%{!?python_sitearch: %global python_sitearch %(%{__python} -c "from distutils.sysconfig import get_python_lib; print get_python_lib(1)")}

%if %{?filter_setup:1}%{!?filter_setup:0}
%filter_provides_in %{python_sitearch}.*\.so$
%filter_setup
%endif

Summary:	NorduGrid ToolKit legacy client tools
Name:		nordugrid-arc-compat
Version:	1.0.1
Release:	0.rc2%{?dist}
URL:		http://www.nordugrid.org/
Source:		%{name}-%{version}rc2.tar.gz
License:	ASL 2.0
Group:		Applications/Internet
BuildRoot:	%{_tmppath}/%{name}-root
BuildRequires:	gsoap-devel >= 2.7.2
BuildRequires:	libxml2-devel >= 2.4.0
BuildRequires:	globus-common-devel
BuildRequires:	globus-ftp-client-devel
BuildRequires:	globus-ftp-control-devel
BuildRequires:	globus-gsi-credential-devel
BuildRequires:	globus-gsi-sysconfig-devel
BuildRequires:	globus-gss-assist-devel
BuildRequires:	globus-io-devel
BuildRequires:	globus-rls-client-devel
BuildRequires:	globus-rsl-devel
BuildRequires:	openldap-devel
BuildRequires:	gettext
%if %{?fedora}%{!?fedora:0} >= 12 || %{?rhel}%{!?rhel:0} >= 6
BuildRequires:	libuuid-devel
%else
BuildRequires:	e2fsprogs-devel
%endif
BuildRequires:	lfc-devel
BuildRequires:	python-devel

%description
The Advanced Resource Connector (ARC) middleware by NorduGrid is a
software solution that uses Grid technologies to enable sharing and
federation of computing and storage resources distributed across
different administrative and application domains. ARC is used to
create Grid infrastructures of various scope and complexity, from
campus to national Grids.

This package contains the ARC client tools. It comprises all the
command line utilities that one needs to submit jobs to the grid, query
their status and to collect the results. It also contains generic data
management tools which can be used with a variety of Grid and non-Grid
protocols and services.

%prep
%setup -q -n %{name}-%{version}rc2

%build
%configure --disable-static --with-docdir=%{_docdir}/%{name}-%{version}
make %{?_smp_mflags}

%install
rm -rf $RPM_BUILD_ROOT
make install DESTDIR=$RPM_BUILD_ROOT

rm $RPM_BUILD_ROOT%{_libdir}/libarclib.so
rm $RPM_BUILD_ROOT%{_libdir}/libarclib.la
rm $RPM_BUILD_ROOT%{python_sitearch}/_arclib.la

%find_lang arclib
%find_lang arccli

cat arclib.lang arccli.lang > %{name}.lang

%clean
rm -rf $RPM_BUILD_ROOT

%post -p /sbin/ldconfig

%postun -p /sbin/ldconfig

%files -f %{name}.lang
%defattr(-,root,root)
%{_bindir}/*
%{_libdir}/libarclib.*
%{python_sitearch}/*
%{_mandir}/man1/*
%config(noreplace) %{_sysconfdir}/giislist
%doc %{_docdir}/%{name}-%{version}

%changelog
* Mon Apr 23 2012 Mattias Ellert <mattias.ellert@fysast.uu.se> - 1.0.1-0.rc2
- Initial compat package
